#ifndef DESC_HISTORY_H
#define DESC_HISTORY_H

#include <qstringlist.h>
#include <qmap.h>
#include <sqlite3.h>
#include "main_configuration_window.h"

#include "userlistelement.h"

class DescriptionsWindow;

class DescHistory : public ConfigurationUiHandler
{
	Q_OBJECT

	public:
		DescHistory();
		~DescHistory();
		int initialize();
		void addEntry(UserListElement* ule);
		virtual void mainConfigurationWindowCreated(MainConfigurationWindow *mainConfigurationWindow);
		QValueList< QMap<QString,QString> > query(QString query, QStringList params);
		void call(QString query, QStringList params);
		QString oneColumn(QString sql, QStringList params);

	private:
		sqlite3* db;
		QString errMsg;
		int menuItemId;
		int userMenuItemId;

		void createDefaultConfiguration();
		DescriptionsWindow* createDescWindow();
		void sort(UserListElements &uleList);

	private slots:
		void statusChanged(UserListElement elem, QString protocolName, const UserStatus &oldStatus, bool massively, bool last);
		void showDescHistoryWin();
		void showDescHistoryWinSelected();
};

extern DescHistory* descHistory;

#endif
